package twitter;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class Usuario {
    private int id;
    private String username;
    private String password;
    private String email;
    private String fechaNacimiento;
    private String fechaCreacion;
    private String urlPhoto;
    private String descripcion;
    private boolean isVerificado;
    private List<Usuario> seguidos;
    private List<Usuario> seguidores;
    private List<Usuario> bloqueados;
    private List<Tweet> tweets;

    public Usuario(int id,String username,String password,String email,String fechaNacimiento,String fechaCreacion,String urlPhoto,String descripcion,boolean isVerificado) {
        this.id=id;
        this.username=username;
        this.password=password;
        this.email=email;
        this.fechaNacimiento=fechaNacimiento;
        this.fechaCreacion=fechaCreacion;
        this.urlPhoto=urlPhoto;
        this.descripcion=descripcion;
        this.isVerificado=isVerificado;
        this.seguidores=new ArrayList<>();
        this.seguidos=new ArrayList<>();
        this.bloqueados=new ArrayList<>();
        this.tweets=new ArrayList<>();
    }

    public String getUsername() {
        return username;
    }

    public String getPassword() {
        return password;
    }

    public String getEmail() {
        return email;
    }

    public String getFechaNacimiento() {
        return fechaNacimiento;
    }
    public String getFechaCreacion() {
        return fechaCreacion;
    }
    public int getId() {
        return id;
    }
    public String getDescripcion() {
        return descripcion;
    }
    public String getUrlPhoto() {
        return urlPhoto;
    }
    public boolean isVerificado() {
        return isVerificado;
    }
    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }
    public void setEmail(String email) {
        this.email = email;
    }
    public void setFechaCreacion(String fechaCreacion) {
        this.fechaCreacion = fechaCreacion;
    }
    public void setFechaNacimiento(String fechaNacimiento) {
        this.fechaNacimiento = fechaNacimiento;
    }
    public void setPassword(String password) {
        this.password = password;
    }
    public void setId(int id) {
        this.id = id;
    }
    public void setUrlPhoto(String urlPhoto) {
        this.urlPhoto = urlPhoto;
    }
    public void setUsername(String username) {
        this.username = username;
    }
    public void setVerificado(boolean isVerificado) {
        this.isVerificado = isVerificado;
    }
    
    public void addSeguido(Usuario seguido) {
        this.seguidos.add(seguido);//el usuario sigue a alguien
        seguido.addSeguidor(this);//a ese alguien le sigue el usuario
    }
    private void addSeguidor(Usuario seguidor){
        this.seguidores.add(seguidor);
    }
    public void removeSeguido(Usuario seguido){
        this.seguidos.remove(seguido);
        seguido.removeSeguidor(this);
    }
    private void removeSeguidor(Usuario seguidor){
        this.seguidores.remove(seguidor);
    }
    public void addBloqueado(Usuario bloqueado){
        this.bloqueados.add(bloqueado);
    }
    public void removeBloqueado(Usuario bloqueado){
        this.bloqueados.remove(bloqueado);
    }

    public void addTweet(Tweet tweet) {
        tweets.add(tweet);
    }

    public void removeTweet(Tweet tweet) {
        tweets.remove(tweet);
    }

    public List<Usuario> getBloqueados() {
        return bloqueados;
    }
    public List<Usuario> getSeguidores() {
        return seguidores;
    }
    public List<Usuario> getSeguidos() {
        return seguidos;
    }
    public List<Tweet> getTweets() {
        return tweets;
    }

    @Override
    public String toString() {
        // TODO Auto-generated method stub
        return getUsername();
    }
}
